#include <winsock2.h>
#pragma comment (lib, "ws2_32.lib")
#include <stdio.h>

int main ()
{
    WSADATA wsaData;
    LPWSAPROTOCOL_INFO wpi;
    DWORD size = 0;
    int err, entries, i;

    err = WSAStartup(MAKEWORD(2,2), &wsaData);
    if (err == SOCKET_ERROR) {
	puts("can't start winsock 2.2");
	return 1;
    }

    /* get the size */
    WSAEnumProtocols(0L, 0L, &size);
    /* set the buffer space */
    wpi = (LPWSAPROTOCOL_INFO) malloc(size);
    /* get the WSAPROTOCOL_INFO array */
    entries = WSAEnumProtocols(0L, wpi, &size);
    for (i = 0; i < entries; i++) {
	printf("%s,\nfamily:%-.3d, type:%-.3d, proto:%-.3d\n\n", wpi[i].szProtocol,
		wpi[i].iAddressFamily, wpi[i].iSocketType, wpi[i].iProtocol);
    }

    free(wpi);
    WSACleanup();
    return 0;
}